<template>
    <div>
        <v-container>
            <v-btn color="error"
                   :disabled="!selected.length"
                   @click="deleteSelected">
                <v-icon>delete</v-icon>
            </v-btn>
            <v-data-iterator :items="items"
                             :items-per-page.sync="itemsPerPage"
                             :page="page"
                             :server-items-length="total"
                             @pagination="paginate"
                             v-model="selected">

                <template v-slot:default="{ items, isSelected, select }">
                    <slot v-bind="{ items, isSelected, select }" />
                </template>

            </v-data-iterator>
        </v-container>
    </div>
</template>

<script>
    export default {
        name: "AssetsManager",
        props: {
            api: {
                type: Object,
                required: true
            }
        },
        data: () => ({
            items: [],
            total: 0,
            page: 1,
            itemsPerPage: 10,
            selected: []
        }),
        computed: {
            numberOfPages () {
                return Math.ceil(this.total / this.itemsPerPage)
            }
        },
        methods: {
            nextPage() {
                if (this.page + 1 <= this.numberOfPages) this.page += 1
            },
            formerPage() {
                if (this.page - 1 >= 1) this.page -= 1
            },
            updateItemsPerPage(number) {
                this.itemsPerPage = number
            },
            paginate(input) {
                this.api.find(input.page, input.itemsPerPage)
                    .then(response => {
                        this.items = response.items;
                        this.total = response.total;
                    });
            },
            // TODO add confirmation window. Then show loading, in case of successful delete remove the items from
            deleteSelected() {
                this.api.delete(this.selected.map(item => item.id))
            }
        }
    }
</script>

<style scoped>

</style>